/*
 *
 * Copyright (C) 1997, 1998, 1999 Yuuji ICHISUGI
 *
 * Permission to use, copy, modify and redistribution this software in
 * whole and in part, for evaluation or research purposes and without fee
 * is hereby granted provided this copyright notice.
 * See CopyrightAndLicensing.txt for licensing condition.
 */


#epp jp.go.etl.epp.EppLibLevel0

package SWAP;

SystemMixin SWAP {
  class Epp {

    extend void initInvokeStyleMacroTable() {
      original();
      defineInvokeStyleMacro(:SWAP, new SWAPMacro());
    }
  }
}

class SWAPMacro extends InvokeStyleMacro {
  
  public Tree call(Tree tree, Tree[] args){
    Tree tmp = new Identifier(genTemp("_T"));
    Obj epp = (Obj)Dynamic.get(:epp);
    return `(block
	     (decl (modifiers)
	      ,(epp!convertExpressionToType(args[0]))
	      (vardecls (varInit ,tmp ,(args[1]))))
	     (expressionStatement
	      (= ,(args[1]) ,(args[2])))
	     (expressionStatement
	      (= ,(args[2]) ,tmp)));
  }
}
